/* eslint-disable react/jsx-filename-extension */
/* eslint-disable no-console */
/* eslint-disable react/display-name */
import React, { Component } from 'react'
import PropTypes from 'prop-types'
import { debounce } from './utils'

function AsyncWrapper(Select) {
  return class extends Component {
    search = debounce(value => {
      this.setLoader(true)
      let { onSearch } = this.props
      onSearch(value)
        .then(options => {
          this.setLoader(false)
          this.setState({
            options
          })
        })
        .catch(err => {
          this.setLoader(false)
          console.error(err)
        })
    }, 500)

    static propTypes = {
      onSearch: PropTypes.func,
      onInputChange: PropTypes.func
    }

    static defaultProps = {
      onInputChange: () => { },
      onSearch: () => { }
    }

    state = {
      loading: false,
      options: []
    }

    setLoader = loading => {
      this.setState({
        loading
      })
    }

    onInputChange = value => {
      this.setLoader(true)
      this.search(value)
    }

    render() {
      const mergedStateAndProps = {
        ...this.props,
        ...this.state,
      }
      return (
        <Select
          {...mergedStateAndProps}
          async
          onInputChange={this.onInputChange}
          setLoader={this.setLoader}
        />
      )
    }
  }
}

export default AsyncWrapper
